//$Pref::Server::ReverseETard::List;
// $Pref::Server::ReverseETard::Enabled = 1;
// $Pref::Server::ReverseETard::List = "cat";
// $Pref::Server::ReverseETard::Delimiter = ",";
// $Pref::Server::ReverseETard::AllowUnlistedWords = 1;

RTB_registerPref("Reverse E-Tard List","Reverse E-Tard","$Pref::Server::ReverseETard::List","string 1000","Script_ReverseETard","","0","0","");
RTB_registerPref("Enabled","Reverse E-Tard","$Pref::Server::ReverseETard::Enabled","bool","Script_ReverseETard",0,"0","0","");
RTB_registerPref("Delimiter","Reverse E-Tard","$Pref::Server::ReverseETard::Delimiter","string 1","Script_ReverseETard",",","0","0","");
RTB_registerPref("Allow Unlisted Words","Reverse E-Tard","$Pref::Server::ReverseETard::AllowUnlistedWords","bool","Script_ReverseETard",0,"0","0","");
RTB_registerPref("Replace Filtered Characters","Reverse E-Tard","$Pref::Server::ReverseETard::ReplaceEnabled","bool","Script_ReverseETard",0,"0","0","");
RTB_registerPref("Replacement Character","Reverse E-Tard","$Pref::Server::ReverseETard::ReplaceChar","string 1","Script_ReverseETard","*","0","0","");

package ReverseETard {
	function serverCmdMessageSent(%cl, %msg) {
		if ($Pref::Server::ReverseETard::Enabled && $Pref::Server::ReverseETard::List !$= "") {
			if ($Pref::Server::ReverseETard::AllowUnlistedWords && $Pref::Server::ReverseETard::ReplaceEnabled) {
				%msg = reverseChatFilterChars(%msg, $Pref::Server::ReverseETard::List, %cl);
				if (trim(%msg) $= "") {
					return;
				}
			} else {
				%error = reverseChatFilter(%msg, $Pref::Server::ReverseETard::List, %cl);
				if (%error) {
					return;
				}
			}
		}

		return parent::serverCmdMessageSent(%cl, %msg);
	}

	function serverCmdTeamMessageSent(%cl, %msg) {
		if ($Pref::Server::ReverseETard::Enabled && $Pref::Server::ReverseETard::List !$= "") {
			if ($Pref::Server::ReverseETard::AllowUnlistedWords && $Pref::Server::ReverseETard::ReplaceEnabled) {
				%msg = reverseChatFilterChars(%msg, $Pref::Server::ReverseETard::List, %cl);
				if (trim(%msg) $= "") {
					return;
				}
			} else {
				%error = reverseChatFilter(%msg, $Pref::Server::ReverseETard::List, %cl);
				if (%error) {
					return;
				}
			}
		}

		return parent::serverCmdTeamMessageSent(%cl, %msg);
	}
};
activatePackage(ReverseETard);

function reverseChatFilterChars(%str, %badlist, %cl) {
	%char = $Pref::Server::ReverseETard::ReplaceChar;

	//generate whitelisted word list
	%wordCount = generateWhitelistedWordList(%badlist);

	//save char indexes
	%lwrStr = strLwr(%str);
	%max = strLen(%lwrStr);
	for (%i = 0; %i < %wordCount; %i++) {
		%word = $whitelistWord[%i];
		%wordLen = $whitelistWordLen[%i];

		%offset = 0;
		while (%offset < %max) {
			%next = strPos(%lwrStr, %word, %offset);
			if (%next < 0) {
				break;
			}
			for (%j = 0; %j < %wordLen; %j++) {
				%whitelistChars = %whitelistChars SPC (%next + %j);
			}
			%offset = %next + 1;
		}
	}
	%whitelistChars = %whitelistChars @ " ";
	// talk("WhitelistChars: [" @ %whitelistChars @ "]");
	// echo("WhitelistChars: [" @ %whitelistChars @ "]");

	for (%i = 0; %i < strLen(%str); %i++) {
		%char = getSubStr(%str, %i, 1);
		if (%char $= " ") {
			%retStr = %retStr @ %char;
		} else if (%char $= "?") {
			%retStr = %retStr @ %char;
		} else if (%char $= "!") {
			%retStr = %retStr @ %char;
		} else if (%char $= "/") {
			%retStr = %retStr @ %char;
		} else if (%char $= ".") {
			%retStr = %retStr @ %char;
		} else if (strPos(%whitelistChars, " " @ %i @ " ") != -1) { //check this last cause its intensive
			%retStr = %retStr @ %char;
		} else {
			%retStr = %retStr @ $Pref::Server::ReverseETard::ReplaceChar;
		}
	}
	if (trim(%retStr) $= "") {
		messageClient(%cl, '', "\c5This is a civilized game.  Please use good words.");
		// messageClient(%cl, '', "\c5Must include the word(s): " @ %badList);
	}
	return %retStr;
}

function reverseChatFilter(%str, %badlist, %cl) {
	%str = strLwr(%str);
	// %str = stripChars(%str, "./'\\\"[]<>{},.!@#$%^&*()-=_+|:;");

	%str = strreplace(%str, "?", " ");
	%str = strreplace(%str, "!", " ");
	%str = strreplace(%str, ".", " ");
	%str = strreplace(%str, "/", " ");

	// echo("String: " @ %str);
	
	%delim = $Pref::Server::ReverseETard::Delimiter;
	// echo(%badList);
	%lastChar = getSubStr(%badList, strlen(%badList) - 1.0, 1);
	if (%lastChar !$= %delim) {
		%badList = %badList @ %delim;
	}

	%offset = 0;
	%max = strLen(%badList) - 1;

	%safety = 0;
	while (%offset < %max) {
		%safety++;
		if (%safety > 1000) {
			echo("ERROR: reverseChatFilter() - loop safety hit");
			return 0;
		}

		%nextDelim = strpos(%badList, %delim, %offset);
		if (%nextDelim == -1.0) {
			%offset = %max;
		}
		%wordLen = %nextDelim - %offset;

		%word = trim(getSubStr(%badList, %offset, %wordLen));
		// echo("CurrWord: " @ %word);
		if ($Pref::Server::ReverseETard::AllowUnlistedWords) {
			// echo("    AllowUnlistedWords = 1");
			if (strstr(%str, %word) != -1.0) {
				return 0;
			}
		} else {
			// echo("    AllowUnlistedWords = 0");
			%str = strreplace(%str, %word, "");
		}
		%offset = %offset + %wordLen + 1.0;
	}

	if (trim(%str) $= "") {
		return 0;
	} else {
		messageClient(%cl, '', "\c5This is a civilized game.  Please use good words.");
		// messageClient(%cl, '', "\c5Must include the word(s): " @ %badList);
		return 1;
	}
}

function generateWhitelistedWordList(%badList) {
	if ($lastWhitelistCheck $= %badList) {
		return $whitelistWordCount;
	}

	$lastWhitelistCheck = %badList;
	$whitelistWordCount = 0;

	%delim = $Pref::Server::ReverseETard::Delimiter;
	// echo(%badList);
	%lastChar = getSubStr(%badList, strlen(%badList) - 1.0, 1);
	if (%lastChar !$= %delim) {
		%badList = %badList @ %delim;
	}

	%offset = 0;
	%max = strLen(%badList) - 1;
	%safety = 0;
	%wordCount = 0;
	while (%offset < %max) {
		%safety++;
		if (%safety > 1000) {
			echo("ERROR: generateWhitelistedWordList() - loop safety hit");
			return 0;
		}

		//get next whitelisted word
		%nextDelim = strpos(%badList, %delim, %offset);
		if (%nextDelim == -1.0) {
			%offset = %max;
		}
		%wordLen = %nextDelim - %offset;

		//record word info
		$whitelistWord[%wordCount] = strLwr(trim(getSubStr(%badList, %offset, %wordLen)));
		$whitelistWordLen[%wordCount] = strLen($whitelistWord[%wordCount]);

		%wordCount++;
		%offset = %offset + %wordLen + 1.0;
	}

	$whitelistWordCount = %wordCount;

	return %wordCount;
}